//+------------------------------------------------------------------+
//|                                               ind_CPBinar_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
//---- input parameters
extern   int      PatternLength=2;
extern   int      PatternID=0;
extern   bool     UsePatternStr=false;
extern   string   BuyPatternStr="10101011";

string PatternBuy;
string PatternSell; 

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   string tmp="";
   for(int i=0;i<StringLen(BuyPatternStr);i++){
      tmp=StringSubstr(BuyPatternStr,i,1)+tmp;
   }
   BuyPatternStr=tmp;

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
//----

      int From=MathPow(2,PatternLength-1);
      int To=MathPow(2,PatternLength)-1;  

      PatternBuy=DecToBin(PatternID);
     
         while(StringLen(PatternBuy)<PatternLength){
            PatternBuy="0"+PatternBuy;
         }
      

      if(UsePatternStr){
         PatternBuy=BuyPatternStr;
         PatternLength=StringLen(PatternBuy);
      }  
      else{
         PatternBuy=DecToBin(PatternID);
            while(StringLen(PatternBuy)<PatternLength){
               PatternBuy="0"+PatternBuy;
            }      
      } 

      PatternSell="";
      
         for(i=0;i<StringLen(PatternBuy);i++){
            if(StringSubstr(PatternBuy,i,1)=="0"){
               PatternSell=PatternSell+"1";
            }
            else{
               PatternSell=PatternSell+"0";            
            }
         }
      if(!UsePatternStr){
         Print("PatternLength = "+PatternLength,", PatternID Max Value = "+To,", PatternBuy = "+PatternBuy,", PatternSell = "+PatternSell); 
      }
      else{
         Print("PatternLength = "+PatternLength,", PatternBuy = "+PatternBuy,", PatternSell = "+PatternSell); 
      }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               ExtMapBuffer1[i]=EMPTY_VALUE;
               ExtMapBuffer2[i]=EMPTY_VALUE;               
               string cp=fCurPat(i);
                  if(cp==PatternBuy){
                     ExtMapBuffer1[i]=Low[i]-Point*5;
                  }
                  if(cp==PatternSell){
                     ExtMapBuffer2[i]=High[i]+Point*5;
                  }
            }
   return(0);
  }
//+------------------------------------------------------------------+

string fCurPat(int j){
   string tmp="";
   for(int i=j;i<j+PatternLength;i++){
      if(Close[i]>Open[i]){
         tmp=tmp+"1";
      }
      if(Close[i]<Open[i]){
         tmp=tmp+"0";
      }      
      if(Close[i]==Open[i]){
         tmp=tmp+"-";
      }         
   }
   return(tmp);
}  

string DecToBin(int n){
   string s = "";
      while(n!=0){
         s=CharToStr(n%2+'0')+s;
         n=n/2;
      }
   return(s);
}